/*----------------------------------
 * sdFileCopy header file
 *
 * v0.0.1 2005/03/27 first release
 * v0.0.2 2005/03/29 MGRǽɲ
 *----------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#define VERSION "0.0.2"

/* Ƽ掠 */
#define MAX_LEN		1024	/* ɤ߹ΰĹ */
#define MAX_TRACK	1024	/* ȥå */
#define MAX_TAGLEN	32	/* κĹ */
#define MAX_BUFSIZE	8096	/* ե륳ԡΥХåե */

/*  */
#define KEY_Tracks	"Tracks"
#define KEY_TrackID	"Track ID"
#define KEY_Name	"Name"
#define KEY_Artist	"Artist"
#define KEY_Album	"Album"
#define KEY_Location	"Location"
#define KEY_PlaylistItems	"Playlist Items"
#define KEY_Playlists	"Playlists"

/*  */
#define TAG_KEY		"key"
#define TAG_STRING	"string"
#define TAG_INTEGER	"integer"
#define TAG_DICT	"dict"
#define TAG_ARRAY	"array"

/* ե饰 */
#define TRUE 1
#define FALSE 0
#define TS_START	'S'
#define TS_END		'E'

/* ϥեϢ */
#define LOC_PREFIX	"file://localhost"
#define OUTFN		"%sSDS_%04d.3g2"	/* ڥե̾ */
#define OUTFN_LEN	12
#define MGRFN		"%sSD_F_%03d.MGR"	/* ե̾ */
#define MGRFN_LEN	12
#define PERMS		0644

/* ȥåǼΰ */
typedef struct {
	int  trackID;	/* ȥåID */
	char *artist;	/* ʼ */
	char *album;	/* Х̾ */
	char *name;	/* ̾ */
	char *location;	/* եΥѥ */
	int  avail;	/* ԡѤߥե饰 */
} trackInfo;

/* ϥե */
typedef struct {
	char *inXmlFilename;	/* xmlե̾ */
	FILE *inXmlFp;		/* xmlեݥ */
	char *outputDirname;	/* ǥ쥯ȥ̾ */
} fileInfo;

/*  */
typedef struct {
	char tag[MAX_TAGLEN];	/* оݥ */
	char value[MAX_LEN];	/* ꤵ줿 */
}  xmlValue;

/* MGRե */
/*  */
#define HEADER	"434E544D00100000000025A00060006400000000000000000000000000000000"
#define LANG	"ja_JP"
#define NONAME	"(NO NAME)"

/* إå */
#define HEAD_DAT	32
typedef struct {
	unsigned char dat[HEAD_DAT]; 		/*  */
} mgrHead;

/* ǡ */
#define DATA_LANG	8
#define DATA_NAME	40
#define DATA_WORK3	32

typedef struct {
	int  fileindex;			/* ե륤ǥå */
	int  work1;			/* 0x01 */
	int  work2;			/* 0x11 */
	char lang[DATA_LANG];		/*  = "ja_JP" */
	int  namelen;			/* ե̾Ĺ */
	char name[DATA_NAME];		/* ե̾ */
	char work3[DATA_WORK3];		/* NULLꥢ */
} mgrData;

/* MGRե */
typedef struct {
	mgrHead head;
	mgrData data[100];
} mgrFile;

int initProc(int, char**, fileInfo*);
int mainProc(fileInfo*);
int getDetail(char*, trackInfo*);
int convLocation(char*, char*);
int tagSearch(char*, char*, char);
int getValue(char*, char*, xmlValue*);
void copyinfo(trackInfo*, trackInfo*);
void printinfo(trackInfo*, int);
int copyFiles(trackInfo*, fileInfo*, int);
int outputMgrFile(trackInfo[], fileInfo*, int);
int outputFile(mgrFile*, fileInfo*, int);
int endProc(fileInfo*);

