#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "x000_sd.h"

/*---------------------------------------------
 * 
 *---------------------------------------------*/
int initProc(int argc, char *argv[], fileInfo *file){
	struct stat infile_stat;
	int rtn;
	size_t t_filename, t_dirname;
	char dirname[4];
	

	/* ѥ᡼å */
	if(argc != 3){
		printf("Usage : %s [Playlist xml File] [Output Directory]\n", argv[0]);
		printf("version %s\n", VERSION);
		return(1);
	}

	/* ե̾ */
	t_filename = strlen(argv[1]);
	
	file->inXmlFilename = (char *)malloc(t_filename + 1);
	memset(file->inXmlFilename, NULL,    t_filename + 1);
	memcpy(file->inXmlFilename, argv[1], t_filename);
	
	/* ǥ쥯ȥ̾ */
	/* ʸ'/'դƤʤ硢ͿƤ */
	memset(dirname, NULL, sizeof(dirname));
	if( argv[2][strlen(argv[2]) - 1] != '/'){
		t_dirname  = strlen(argv[2]) + 1;
		memcpy(dirname, "%s/", 3);
	}else{
		t_dirname = strlen(argv[2]);
		memcpy(dirname, "%s", 2);
	}
	file->outputDirname = (char *)malloc(t_dirname + 1);
	memset(file->outputDirname, NULL,    t_dirname + 1);
	sprintf(file->outputDirname, dirname, argv[2]);
	
	/* եå */
	rtn = stat(file->inXmlFilename, &infile_stat);
	if((infile_stat.st_mode & S_IFMT) != S_IFREG){
		/* ̾Υե̵(ǥ쥯ȥFIFOǥХʤ) */
		printf("%s is not ordinary file.\n", file->inXmlFilename);
		return(1);
	}

	/* ե륪ץ */
	file->inXmlFp = fopen(file->inXmlFilename, "r"); /* ɼѤǳ */

	if(file->inXmlFp == NULL){  /* Ƚ */
		/* ʤä */
		printf("could not open file %s\n", argv[1]);
		return(1);

	}

	/* ǥ쥯ȥå */
	rtn = stat(file->outputDirname, &infile_stat);
	
	/* ǥ쥯ȥ꤫ */
	if((infile_stat.st_mode & S_IFMT) != S_IFDIR){
		printf("%s is not directory.\n", file->outputDirname);
		return(1);
	}
	/* 񤭹߸¤ͭ뤫 */
	if((infile_stat.st_mode & S_IWUSR) != S_IWUSR){
		printf("permission denied. %s\n", file->outputDirname);
		return(1);
	}

	return(0);

}

