#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include "x000_sd.h"

/*---------------------------------------------
 * 
 *   ץ쥤ꥹxmlեιʸԤ
 *   եΥԡMGRեκԤ
 *---------------------------------------------*/
int mainProc(fileInfo *file){

	char inbuf[MAX_LEN];
	xmlValue xml;
	int dictLevel;
	int i, j;
	int trackNum;  /* ȥåη */
	int rtn;

	trackInfo album[MAX_TRACK];
	trackInfo sorted[MAX_TRACK];

	memset(inbuf, NULL, sizeof(inbuf));
	memset(album, NULL, sizeof(album));
	memset(sorted, NULL, sizeof(sorted));

	/*-----------------------------------*/
	/* Track󤬳ϤޤɤФ */
	/*-----------------------------------*/
	while(fgets(inbuf, MAX_LEN, file->inXmlFp)){
		if(getValue(inbuf, TAG_KEY, &xml) == TRUE){
			/* ȥåˤ֤Ĥäȴ */
			if(memcmp(xml.value, KEY_Tracks,
				  sizeof(KEY_Tracks)) == 0) break;
		}
	}

	/*---------------------*/
	/* Trackɤ߹ */
	/*---------------------*/
	i = 0;
	dictLevel = 0;
	/* dictLevel = 1 Ǥ֤ϡTrackID򼨤ͤ */
	/* dictLevel = 2 Ǥ֤϶ʾ򸡺 */
	/* dictLevel = 1 äȤ϶ʿ󥿤򥢥å */
	while(fgets(inbuf, MAX_LEN, file->inXmlFp) && 
	      i < MAX_TRACK                        ){

		/* dictȽ -----------------------------------------*/
		if(tagSearch(inbuf, TAG_DICT, TS_START) == TRUE){
			/* dictͥȥ٥뤬徺 */
			dictLevel++;
			continue;
		}

		/* dictλȽ -----------------------------------------*/
		if(tagSearch(inbuf, TAG_DICT, TS_END) == TRUE){

			/* dictͥȥ٥߲ */
			dictLevel--;

			/* äȤTrack󤬽λ */
			if(dictLevel == 0){
				break;
			}

			/*  äȤ϶ʿ󥿤򥫥ȥå */
			if(dictLevel == 1){
				/*printinfo(&(album[i]), i); */

				i++;
			}

			continue;
		}

		/* dictlevel = 1 Ǥ -----------------------------*/
		if(dictLevel == 1){
			/* ȥåID */
			if(getValue(inbuf, TAG_KEY, &xml) == TRUE){
				album[i].trackID = atoi(xml.value);
				continue;

			}

		}

		/* dictLevel = 2 Ǥ -----------------------------*/
		if(dictLevel == 2){
			/* ʾ */
			getDetail(inbuf, &(album[i]));
			continue;

		}

	}

	/* ȥå */
	trackNum = i;
	
	/* ȥåͤä硢۾ｪλ */
	if(trackNum >= MAX_TRACK){
		printf("ABORT! track num over %d.\n", MAX_TRACK);
		return(1);
	}
	
	printf("%d titles are found\n", trackNum);

	/*------------------------*/
	/* Playlistɤ߹ */
	/*    ʽ            */
	/*------------------------*/
	/*  Playlist Items ޤɤФ */
	while(fgets(inbuf, MAX_LEN, file->inXmlFp)){
		if(getValue(inbuf, TAG_KEY, &xml) == TRUE){

			/* ȥåˤ֤Ĥäȴ */
			if(memcmp(xml.value, KEY_PlaylistItems,
				  sizeof(KEY_PlaylistItems)) == 0) break;

		}
	}
	
	/* PlaylistItemsɤ߹ߡν¤ؤ */
	i = 0;
	j = 0;
	while(fgets(inbuf, MAX_LEN, file->inXmlFp) && 
	      i < MAX_TRACK                        ){
		/* λΥ򸡽Ф齪λ */
		if(tagSearch(inbuf, TAG_ARRAY, TS_END) == TRUE) break;

		/* KEYʤä鼡 */
		if(getValue(inbuf, TAG_KEY, &xml) != TRUE) continue;

		/* TrackIDΥ򸡺 */
		if(memcmp(xml.value, KEY_TrackID, 
				sizeof(KEY_TrackID)) != 0) continue;

		/* TrackID */
		if(getValue(inbuf, TAG_INTEGER, &xml) != TRUE) continue;

		/* ɤ߹ߺѤߤΥȥå򸡺 */
		for(j = 0; j < trackNum && album[j].trackID != atoi(xml.value) ; j++);
		
		/* ˥ԡ */
		copyinfo(&(album[j]), &(sorted[i]));

		i++;

	}

	/*----------------*/
	/* ե륳ԡ */
	/*----------------*/
	for(i = 0; i < trackNum; i++){
		copyFiles(&(sorted[i]), file, i);
	}

	/*-----------------*/
	/* MGRե */
	/*-----------------*/
	rtn = outputMgrFile(sorted, file, trackNum);


	/* ҤŤ */
	for(i = 0; i < MAX_TRACK; i++){
		if(album[i].artist    != NULL) free(album[i].artist);
		if(album[i].album     != NULL) free(album[i].album);
		if(album[i].name      != NULL) free(album[i].name);
		if(album[i].location  != NULL) free(album[i].location);
		if(sorted[i].artist   != NULL) free(sorted[i].artist);
		if(sorted[i].album    != NULL) free(sorted[i].album);
		if(sorted[i].name     != NULL) free(sorted[i].name);
		if(sorted[i].location != NULL) free(sorted[i].location);
	}
	return(rtn);

}

/*----------------------------------------------
 * ڥե륳ԡ
 *   locationǼեѥ᡼
 *   outputDir˥ԡ
 *----------------------------------------------*/
int copyFiles(trackInfo *in, fileInfo *file, int i){
	int from_fd, to_fd;
	char buffer[MAX_BUFSIZE];
	char *outFilename, *inFilename;
	int outFilenameLen, n;
	
	in->avail = FALSE;	/* ԡ̤ */

	/* ϥե̾ */
	outFilename = (char *)malloc(strlen(file->outputDirname) + OUTFN_LEN + 1);
	memset(outFilename, NULL, strlen(file->outputDirname) + OUTFN_LEN + 1);
	sprintf(outFilename, OUTFN, file->outputDirname, i);
	
	/* ϥե̾Υå */
	if(strstr(in->location, LOC_PREFIX) == NULL){
		/* Ƭ̵ */
		printf("location error %s\n", in->location);
		if(outFilename != NULL) free(outFilename);
		return(1);
	}
	inFilename = (in->location + sizeof(LOC_PREFIX) - 1);
	
	/* ϥե륪ץ */
	if((from_fd = open(inFilename, O_RDONLY)) == -1){
		printf("can't open file %s\n", inFilename);
		if(outFilename != NULL) free(outFilename);
		return(1);
	}
	if((to_fd = creat(outFilename, PERMS)) == -1){
		printf("can't create file %s\n", outFilename);
		close(from_fd);
		if(outFilename != NULL) free(outFilename);
		return(1);
	}
	
	/* ե륳ԡ */
	while(( n = read(from_fd, buffer, MAX_BUFSIZE)) > 0){
		if(write(to_fd, buffer, n) != n){
			printf("write error %s\n", outFilename);
			close(from_fd);
			close(to_fd);
			if(outFilename != NULL) free(outFilename);
			return(1);
		}
	}
	
	printf("copied %s, %s\n", outFilename, in->name);
	
	close(from_fd);
	close(to_fd);
	if(outFilename != NULL) free(outFilename);

	in->avail = TRUE;

	return(0);
	
}

/*----------------------------------------------
 * ȥå󥳥ԡ
 *   ¤ƱΤƤΥԡԤ
 *   ǡNULLͤäϲ⤷ʤ
 *----------------------------------------------*/
void copyinfo(trackInfo *in, trackInfo *out){
	size_t	strSize;
	/* ȥåID */
	out->trackID = in->trackID;
	
	/* ԡѤߥե饰 */
	out->avail   = in->avail;
	
	/* ʼ */
	if(in->artist != NULL){
		strSize = strlen(in->artist);
		out->artist = (char *)malloc(strSize + 1);
		memset(out->artist, NULL,       strSize + 1);
		memcpy(out->artist, in->artist, strSize);
	}
	
	/* Х̾ */
	if(in->album != NULL){
		strSize = strlen(in->album);
		out->album = (char *)malloc(strSize + 1);
		memset(out->album, NULL,      strSize + 1);
		memcpy(out->album, in->album, strSize);
	}
	
	/* ̾ */
	if(in->name != NULL){
		strSize = strlen(in->name);
		out->name = (char *)malloc(strSize + 1);
		memset(out->name, NULL,     strSize + 1);
		memcpy(out->name, in->name, strSize);
	}
	
	/* եѥ */
	if(in->location != NULL){
		strSize = strlen(in->location);
		out->location = (char *)malloc(strSize + 1);
		memset(out->location, NULL,         strSize + 1);
		memcpy(out->location, in->location, strSize);
	}
	

}




